/*
File keynavigation.js
@Description - tic tac toe game logic and implementaion

 */
var selplayer;
var tv;
var allMenuObject = [];
var cntIndex = 0;
var gameStarted = false;
var gameEnded = false;
var backHighlight = 1;
//backHighlight - 1 : not highlighted,2:highlighted,3:gamestarted
/*
Function ready()
@param
@Description - This function is called when DOm is ready.This has the implimentation of keydown
Returns  -void
 */
$('document').ready(function () {

	$(".main_btn").on("click", function (event) {
		backButtonSelect();
	});
	$(".main_btn").on("mouseenter mouseleave", function (event) {
		highlightBack();
	});
	$("#players li img").each(function (i) {
		$(this).addClass("playerImgNormal");
		$(this).on("mouseenter mouseleave", function (event) {
			resetHighlight();
			$(this).toggleClass("playerImgHover");
			cntIndex = i;
		});
	});
	var elem = $("#players li img");
	$("#players li img").click(function () {
		playerClicked(this);

	});
	for (var i = 0; i < elem.length; i++) {
		allMenuObject.push(elem[i]);
	}

	$(allMenuObject[0]).toggleClass("playerImgHover");
	/*
	Function keydown()
	@param -event
	@Description - This has the implimentation of keydown like lfet right up and donw
	Returns  -void
	 */
	$(document).keydown(function (event) {

		var key = event.keycode || event.which;
		switch (key) {
		case VK_BACK:
			backButtonSelect();
			break;
		case VK_RIGHT:
			if (gameStarted) {
				squareMove("right");
			} else if (gameEnded) {
				if (backHighlight == 2) {
					highlightPrevious();
				} else if (backHighlight == 1) {
					highlightBack();
				}
			} else {
				if (allMenuObject[cntIndex + 1] != undefined && backHighlight != 2) {
					cntIndex++;
					resetHighlight();
					$(allMenuObject[cntIndex]).toggleClass("playerImgHover");
				}
			}
			break;

		case VK_LEFT:
			if (gameStarted) {
				squareMove("left");
			} else if (gameEnded) {
				if (backHighlight == 2) {
					highlightPrevious();
				} else if (backHighlight == 1) {
					highlightBack();
				}

			} else {
				if (allMenuObject[cntIndex - 1] != undefined && backHighlight != 2) {
					cntIndex--;
					resetHighlight();
					$(allMenuObject[cntIndex]).toggleClass("playerImgHover");
				}
			}
			break;
		case VK_UP:

			if (backHighlight == 1) {
				highlightBack();
			} else {
				squareMove("up");
			}
			break;
		case VK_DOWN:
			if (backHighlight == 2) {
				highlightPrevious();
			} else {
				squareMove("down");
			}

			break;
		case VK_ENTER:
			if (backHighlight == 2) {
				backButtonSelect();
			} else if (gameStarted) {
				selectSquare();
			} else if (gameEnded) {
				restart();
			} else {
				playerClicked(allMenuObject[cntIndex]);
			}
			break;
		}

	});

});
/*
Function backButtonSelect()
@param - none
@Description - This function implements back button functionality at different stages.
Returns  -void
 */

function backButtonSelect() {
	if (gameStarted || gameEnded) {
		history.go(0);
	} else {
		if (window.NetCastBack) {
			window.NetCastBack();
		}
	}
}
/*
Function resetHighlight()
@param -
@Description - This function implements  resetting of the highlightig of button on key press.
Returns  -void
 */
function resetHighlight() {
	$("#players li img").each(function (i) {
		$(this).removeClass("playerImgHover").addClass("playerImgNormal");
	});
	$(".main_btn li").removeClass("btn_focus");
	$(".main_btn li ").addClass("btn_default");
}

/*
Function highlightBack()
@param -
@Description - This function implements highlightig of back button on down key press.
Returns  -void
 */
function highlightBack() {
	backHighlight = 2;
	$(".main_btn li ").removeClass("btn_default");
	$(".main_btn li ").addClass("btn_focus");
	if (gameStarted) {
		$("#highlight").css("display", "none");
	} else if (gameEnded) {
		$("#btn_restart").removeClass("buttonSelected").addClass("button");
	} else {
		$("#players li img").each(function (i) {
			$(this).removeClass("playerImgHover").addClass("playerImgNormal");
		});
	}
}
/*
Function highlightPrevious()
@param -
@Description - This function implements highlightig of the previous button from back button on down key press.
Returns  -void
 */
function highlightPrevious() {
	backHighlight = 1;
	$(".main_btn li ").removeClass("btn_focus");
	$(".main_btn li ").addClass("btn_default");
	if (gameStarted) {
		backHighlight = 3;
		$("#highlight").css("display", "block");
		$("#highlight").css("left", position_arr[position_index].x);
		$("#highlight").css("top", position_arr[position_index].y);
	} else if (gameEnded) {
		$("#btn_restart").removeClass("button").addClass("buttonSelected");
	} else {
		$("#players li img").each(function (i) {
			$(this).removeClass("playerImgHover").addClass("playerImgNormal");
		});
		$(allMenuObject[cntIndex]).toggleClass("playerImgHover");
	}
}

/*
Function playerClicked()
@param -obj-the current selected HTML object
@Description - This function check the current selected item and marks the other as TV.
Returns  -void
 */
function playerClicked(obj) {
	backHighlight = 3;
	var dir = "Left"
	var selItem = obj;
	selplayer = selItem;
	playSound(1);
	$("#players li img").each(function (i) {
		var curItem;
		$(this).addClass("animateclass" + dir);
		$(this).off("mouseenter mouseleave click");
		$("#selectText h2").html("Play Now");
		if (this.alt != selItem.alt) {
			curItem = this;
			tv = curItem;
		}
		dir = "Right";
		this.addEventListener('webkitAnimationEnd',

			function (event) {
			$("#game").css("display", "block");

			if (curItem) {
				$(".player_name").css("display", "block");
				$(".player_name").css("position", "absolute");
				$(".player_name").css("width", $(curItem).width());
				$(".player_name").css("left", $(curItem).offset().left - 10);
				$(".player_name").css("top", $(curItem).offset().top + 170);

				paintBoard();
			}
		}, false);

	});
	allMenuObject = [];
}
/*
Function playSound()
@param -num -number of the sound element
@Description - This function is called for playing the sound effect..
Returns  -void
 */
function playSound(num) {
	var sound = document.getElementById("sound" + num);
	sound.play();
}
